/*
   Copyright (c) 2014 by Plexim GmbH
   All rights reserved.

   A free license is granted to anyone to use this software for any legal
   non safety-critical purpose, including commercial applications, provided
   that:
   1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
   2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */

#ifndef PIL_CTRL_H
#define PIL_CTRL_H

#include "pil.h"
#include "HAL_obj.h"

typedef struct EPWM_MIRROR {
	uint16_t PwmEnabled;
	uint16_t Cmp1A;
	uint16_t Cmp2A;
	uint16_t Cmp3A;
	uint16_t TBCTL;
	uint16_t ETSEL;
	uint16_t ETPS;
	uint16_t TBPRD;
	uint16_t CMPCTL;
	uint16_t AQCTLA;
	uint16_t AQCSFRC;
} EPWM_MIRROR;

typedef struct ADC_OVERRIDE {
	PIL_OVERRIDE_PROBE(uint16_t, Result0);
	PIL_OVERRIDE_PROBE(uint16_t, Result1);
	PIL_OVERRIDE_PROBE(uint16_t, Result2);
	PIL_OVERRIDE_PROBE(uint16_t, Result3);
	PIL_OVERRIDE_PROBE(uint16_t, Result4);
	PIL_OVERRIDE_PROBE(uint16_t, Result5);
	PIL_OVERRIDE_PROBE(uint16_t, Result6);
	PIL_OVERRIDE_PROBE(uint16_t, Result7);
} ADC_OVERRIDE;

extern HAL_Handle drvHandleMirror;
extern EPWM_MIRROR EpwmMirror;
extern ADC_OVERRIDE AdcOverride;

extern bool_t PilIsAllowed();
extern void PilInitOverrideProbes(void);
extern void PilCallback(PIL_CtrlCallbackReq_t aCallbackReq);

#endif
